diff --git a/src/main/java/net/minecraft/core/net/command/helpers/MinMaxBounds.java b/src/main/java/net/minecraft/core/net/command/helpers/MinMaxBounds.java
new file mode 100644
index 000000000..884c50dc1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/MinMaxBounds.java
@@ -0,0 +1,144 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.function.Function;
+import java.util.function.Supplier;
+
+public abstract class MinMaxBounds<T extends Number> {
+    private static final SimpleCommandExceptionType EMPTY_VALUE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.range.empty"));
+    private static final SimpleCommandExceptionType SWAPPED_VALUES = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.range.swapped"));
+
+    @Nullable
+    protected final T min;
+    @Nullable
+    protected final T max;
+
+    public MinMaxBounds(@Nullable T min, @Nullable T max) {
+        this.min = min;
+        this.max = max;
+    }
+
+    public T getMax() {
+        return this.max;
+    }
+
+    public T getMin() {
+        return this.min;
+    }
+
+    public boolean isAny() {
+        return this.max == null && this.min == null;
+    }
+
+    public static <T extends Number, R extends MinMaxBounds<T>> R fromReader(StringReader reader, Function<String, T> parser, Supplier<SimpleCommandExceptionType> supplier, BoundsFromReaderFactory<T, R> boundsFromReaderFactory) throws CommandSyntaxException {
+        if (!reader.canRead()) throw EMPTY_VALUE.createWithContext(reader);
+        int cursor = reader.getCursor();
+        try {
+            T number1 = readNumber(reader, parser, supplier);
+            T number2;
+            if (reader.canRead(2) && reader.peek() == '.' && reader.peek(1) == '.') {
+                reader.skip();
+                reader.skip();
+                number2 = readNumber(reader, parser, supplier);
+            } else {
+                number2 = number1;
+            }
+            if (number1 == null && number2 == null) {
+                throw EMPTY_VALUE.createWithContext(reader);
+            }
+            return boundsFromReaderFactory.create(reader, number1, number2);
+        } catch (CommandSyntaxException exception) {
+            reader.setCursor(cursor);
+            throw EMPTY_VALUE.createWithContext(reader);
+        }
+    }
+
+    private static <T extends Number> T readNumber(StringReader reader, Function<String, T> parser, Supplier<SimpleCommandExceptionType> supplier) throws CommandSyntaxException {
+        int cursor = reader.getCursor();
+        while (reader.canRead() && isAllowedChatCharacter(reader)) {
+            reader.skip();
+        }
+        String numberString = reader.getString().substring(cursor, reader.getCursor());
+        if (numberString.isEmpty()) {
+            return null;
+        }
+        try {
+            return parser.apply(numberString);
+        } catch (NumberFormatException e) {
+            throw supplier.get().createWithContext(reader);
+        }
+    }
+
+    private static boolean isAllowedChatCharacter(StringReader reader) {
+        char c = reader.peek();
+        if (c >= '0' && c <= '9' || c == '-') {
+            return true;
+        }
+        if (c == '.') {
+            return !reader.canRead(2) || reader.peek(1) != '.';
+        }
+        return false;
+    }
+
+    @FunctionalInterface
+    protected interface BoundsFromReaderFactory<T extends Number, R extends MinMaxBounds<T>> {
+        R create(StringReader reader, T min, T max) throws CommandSyntaxException;
+    }
+
+    public static class Integers extends MinMaxBounds<Integer> {
+        public static Integers ANY = new Integers(null, null);
+
+        public Integers(@Nullable Integer min, @Nullable Integer max) {
+            super(min, max);
+        }
+
+        private static Integers create(StringReader stringReader, @Nullable Integer integer1, @Nullable Integer integer2) throws CommandSyntaxException {
+            if (integer1 != null && integer2 != null && integer1 > integer2) {
+                throw SWAPPED_VALUES.createWithContext(stringReader);
+            }
+            return new Integers(integer1, integer2);
+        }
+
+        public boolean contains(int number) {
+            if (this.min != null && this.min > number) {
+                return false;
+            }
+            return this.max == null || this.max >= number;
+        }
+
+        public static MinMaxBounds.Integers fromReader(StringReader reader) throws CommandSyntaxException {
+            return MinMaxBounds.fromReader(reader, Integer::parseInt, CommandSyntaxException.BUILT_IN_EXCEPTIONS::readerExpectedInt, Integers::create);
+        }
+    }
+
+    public static class Doubles extends MinMaxBounds<Double> {
+        public static Doubles ANY = new Doubles(null, null);
+
+        public Doubles(@Nullable Double min, @Nullable Double max) {
+            super(min, max);
+        }
+
+        private static Doubles create(StringReader stringReader, @Nullable Double double1, @Nullable Double double2) throws CommandSyntaxException {
+            if (double1 != null && double2 != null && double1 > double2) {
+                throw SWAPPED_VALUES.createWithContext(stringReader);
+            }
+            return new Doubles(double1, double2);
+        }
+
+        public boolean contains(double number) {
+            if (this.min != null && this.min > number) {
+                return false;
+            }
+            return this.max == null || this.max >= number;
+        }
+
+        public static MinMaxBounds.Doubles fromReader(StringReader reader) throws CommandSyntaxException {
+            return MinMaxBounds.fromReader(reader, Double::parseDouble, CommandSyntaxException.BUILT_IN_EXCEPTIONS::readerExpectedInt, Doubles::create);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java b/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java
new file mode 100644
index 000000000..e13c5cf3f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParameterTypes.java
@@ -0,0 +1,53 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class WorldFeatureParameterTypes {
+    private static final Map<Class<?>, ReadFunction> FEATURE_MAP = new HashMap<>();
+
+    static {
+        FEATURE_MAP.put(Integer.TYPE, (reader, parser) -> reader.readInt());
+        FEATURE_MAP.put(Block.class, WorldFeatureParameterTypes::parseBlock);
+        FEATURE_MAP.put(String.class, (reader, parser) -> reader.readString());
+    }
+
+    public static void register(Class<?> clazz, ReadFunction function) {
+        FEATURE_MAP.put(clazz, function);
+    }
+
+    public static Map<Class<?>, ReadFunction> getFeatures() {
+        return new HashMap<>(FEATURE_MAP);
+    }
+
+    public static Object get(Class<?> clazz, StringReader stringReader, WorldFeatureParser parser) throws CommandSyntaxException {
+        if (FEATURE_MAP.containsKey(clazz)) return FEATURE_MAP.get(clazz).handle(stringReader, parser);
+        throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownCommand().createWithContext(stringReader);
+    }
+
+    private static Block parseBlock(StringReader reader, WorldFeatureParser parser) throws CommandSyntaxException {
+        parser.setSuggestions(CommandHelper.SUGGEST_BLOCKS);
+
+        int cursor = reader.getCursor();
+        final String string = reader.readString();
+
+        for (Block blockInList : Block.blocksList) {
+            if (blockInList == null) continue;
+            if (CommandHelper.matchesKeyString(blockInList.getKey(), string)) {
+                return blockInList;
+            }
+        }
+        reader.setCursor(cursor);
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.block.invalid_block"));
+    }
+
+    public interface ReadFunction {
+        Object handle(StringReader reader, WorldFeatureParser parser) throws CommandSyntaxException;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java b/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java
new file mode 100644
index 000000000..a52b0462a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/WorldFeatureParser.java
@@ -0,0 +1,155 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.b100.utils.Utils;
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.lang.reflect.Constructor;
+import java.lang.reflect.Parameter;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Map;
+import java.util.concurrent.CompletableFuture;
+import java.util.function.BiFunction;
+import java.util.function.Consumer;
+
+public class WorldFeatureParser {
+    private final SimpleCommandExceptionType NO_PARAMETERS = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.world_feature.no_parameters"));
+
+    private final StringReader reader;
+    private int startPosition = 0;
+    
+    private BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> suggestions = CommandHelper.NO_SUGGESTIONS;
+    
+    public WorldFeatureParser(StringReader reader) {
+        this.reader = reader;
+    }
+
+    private CompletableFuture<Suggestions> suggestWorldFeatures(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        SuggestionsBuilder suggestionsBuilder2 = suggestionsBuilder.createOffset(this.startPosition);
+        consumer.accept(suggestionsBuilder2);
+        return suggestionsBuilder.add(suggestionsBuilder2).buildFuture();
+    }
+
+    public WorldFeature parse() throws CommandSyntaxException {
+        this.startPosition = this.reader.getCursor();
+        this.suggestions = this::suggestWorldFeatures;
+        final String string = this.reader.readString();
+        Class<? extends WorldFeature> worldFeatureClass = null;
+
+        for (Map.Entry<String, Class<? extends WorldFeature>> entry : CommandHelper.WORLD_FEATURES.entrySet()) {
+            if (CommandHelper.matchesKeyString(entry.getKey(), string)) {
+                worldFeatureClass = entry.getValue();
+            }
+        }
+
+        if (worldFeatureClass == null) throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(this.reader);
+
+        boolean hasParameters = false;
+        Constructor<?> constructor = null;
+
+        for (Constructor<?> c : worldFeatureClass.getConstructors()) {
+            constructor = c;
+            hasParameters = c.getParameters().length != 0;
+        }
+
+        if (!hasParameters && constructor != null) {
+            if (this.reader.canRead() && this.reader.peek() == '[') {
+                throw NO_PARAMETERS.createWithContext(this.reader);
+            }
+            try {
+                return (WorldFeature) constructor.newInstance();
+            } catch (Exception e) {
+                throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.world_feature.invalid_world_feature"));
+            }
+        }
+
+        return this.parseParameters(worldFeatureClass);
+    }
+
+    private WorldFeature parseParameters(Class<? extends WorldFeature> worldFeatureClass) throws CommandSyntaxException {
+        this.suggestions = this::suggestOpenParameters;
+        Constructor<?> constructor;
+        if (this.reader.canRead()) this.suggestions = CommandHelper.NO_SUGGESTIONS;
+        if (this.reader.canRead() && this.reader.peek() == '[') {
+            List<Object> parameters = new ArrayList<>();
+            this.reader.skip();
+
+            Constructor<?> c = getConstructorWithMostParameters(worldFeatureClass.getConstructors());
+
+            if (c == null) throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(this.reader);
+
+            for (Parameter parameter : c.getParameters()) {
+                this.suggestions = CommandHelper.NO_SUGGESTIONS;
+                this.reader.skipWhitespace();
+                Object parsedParameter = this.parseParameter(parameter);
+                parameters.add(parsedParameter);
+
+                boolean lastParameter = parameters.size() == c.getParameters().length;
+
+                this.reader.skipWhitespace();
+                if (!this.reader.canRead()) {
+                    this.suggestions = lastParameter ? this::suggestParametersClose : this::suggestParametersNext;
+                    throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(this.reader);
+                }
+                if ((lastParameter && this.reader.peek() == ']') || (!lastParameter && this.reader.peek() == ','))
+                    this.reader.skip();
+                else throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(this.reader);
+            }
+
+            constructor = c;
+            this.suggestions = CommandHelper.NO_SUGGESTIONS;
+
+            try {
+                return (WorldFeature) constructor.newInstance(Utils.toArray(Object.class, parameters));
+            } catch (Exception e) {
+                throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.world_feature.invalid_world_feature"));
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.world_feature.invalid_world_feature"));
+    }
+
+    private Object parseParameter(Parameter parameter) throws CommandSyntaxException {
+        this.suggestions = CommandHelper.NO_SUGGESTIONS;
+        return WorldFeatureParameterTypes.get(parameter.getType(), this.reader, this);
+    }
+
+    private CompletableFuture<Suggestions> suggestOpenParameters(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        suggestionsBuilder.suggest(String.valueOf('['));
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestParametersNext(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        suggestionsBuilder.suggest(String.valueOf(','));
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestParametersClose(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        suggestionsBuilder.suggest(String.valueOf(']'));
+        return suggestionsBuilder.buildFuture();
+    }
+
+    public void setSuggestions(BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> biFunction) {
+        this.suggestions = biFunction;
+    }
+
+    public CompletableFuture<Suggestions> fillSuggestions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        return this.suggestions.apply(suggestionsBuilder.createOffset(this.reader.getCursor()), consumer);
+    }
+
+    private static Constructor<?> getConstructorWithMostParameters(Constructor<?>[] constructors) {
+        if (constructors.length == 0) return null;
+        Constructor<?> constructor = constructors[0];
+        for (Constructor<?> c : constructors) {
+            if (c.getParameters().length <= constructor.getParameters().length) continue;
+            constructor = c;
+        }
+        return constructor;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/util/BeautifulNbt.java b/src/main/java/net/minecraft/core/net/command/util/BeautifulNbt.java
new file mode 100644
index 000000000..6907afe06
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/BeautifulNbt.java
@@ -0,0 +1,76 @@
+package net.minecraft.core.net.command.util;
+
+import com.mojang.nbt.*;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.List;
+
+public class BeautifulNbt {
+    public static String toBeautifulNbt(@NotNull CompoundTag nbt) {
+        StringBuilder builder = new StringBuilder("{");
+        boolean comma = false;
+        for (Tag<?> tag : nbt.getValue().values()) {
+            if (comma) builder.append(", ");
+            builder.append(tag.getTagName()).append(": ").append(element(tag instanceof CompoundTag ? tag : tag.getValue()));
+            comma = true;
+        }
+        return builder.append("}").toString();
+    }
+
+    private static String element(Object o) {
+        if (o instanceof byte[] || o instanceof short[] || o instanceof double[] || o instanceof List<?>) {
+            return collection(o);
+        }
+        if (o instanceof Byte) {
+            return o + "b";
+        }
+        if (o instanceof Short) {
+            return o + "s";
+        }
+        if (o instanceof Long) {
+            return o + "l";
+        }
+        if (o instanceof Float) {
+            return o + "f";
+        }
+        if (o instanceof String) {
+            return "\"" + o + "\"";
+        }
+        return o instanceof CompoundTag ? toBeautifulNbt((CompoundTag) o) : o.toString();
+    }
+
+    private static String collection(Object o) {
+        StringBuilder result = new StringBuilder("[");
+        boolean comma = false;
+        if (o instanceof byte[]) {
+            result.append("B; ");
+            for (byte element : ((byte[])o)) {
+                if (comma) result.append(", ");
+                result.append(element(element));
+                comma = true;
+            }
+        } else if (o instanceof short[]) {
+            result.append("S; ");
+            for (short element : ((short[])o)) {
+                if (comma) result.append(", ");
+                result.append(element(element));
+                comma = true;
+            }
+        } else if (o instanceof double[]) {
+            result.append("D; ");
+            for (double element : ((double[])o)) {
+                if (comma) result.append(", ");
+                result.append(element(element));
+                comma = true;
+            }
+        } else if (o instanceof List<?>) {
+            //noinspection unchecked
+            for (Tag<?> element : ((List<Tag<?>>)o)) {
+                if (comma) result.append(", ");
+                result.append(element(element.getValue()));
+                comma = true;
+            }
+        }
+        return result.append("]").toString();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java b/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
new file mode 100644
index 000000000..d459e8ae3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
@@ -0,0 +1,160 @@
+package net.minecraft.core.net.command.util;
+
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.Tag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+import net.minecraft.core.util.helper.LoggedPrintStream;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.HashMap;
+import java.util.Locale;
+import java.util.Map;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+import java.util.function.BiFunction;
+import java.util.function.Consumer;
+
+public class CommandHelper {
+    public static final Map<String, Class<? extends WorldFeature>> WORLD_FEATURES = new HashMap<>();
+
+    public static final BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> NO_SUGGESTIONS = (builder, consumer) -> builder.buildFuture();
+    public static final BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> SUGGEST_BLOCKS = (builder, consumer) -> {
+        String remaining = builder.getRemaining().toLowerCase(Locale.ROOT);
+        for (Block block : Block.blocksList) {
+            if (block == null) continue;
+            CommandHelper.getStringToSuggest(block.getKey(), remaining).ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    };
+
+    public static CompletableFuture<Suggestions> suggest(String string, SuggestionsBuilder suggestionsBuilder) {
+        String stringRemaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
+        if (matchesSubStr(stringRemaining, string.toLowerCase(Locale.ROOT))) suggestionsBuilder.suggest(string);
+        return suggestionsBuilder.buildFuture();
+    }
+
+    public static CompletableFuture<Suggestions> suggest(Iterable<String> iterable, SuggestionsBuilder suggestionsBuilder) {
+        String string = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
+        for (String string2 : iterable) {
+            if (!matchesSubStr(string, string2.toLowerCase(Locale.ROOT))) continue;
+            suggestionsBuilder.suggest(string2);
+        }
+        return suggestionsBuilder.buildFuture();
+    }
+
+    public static boolean matchesSubStr(String string, String string2) {
+        int i = 0;
+        while (!string2.startsWith(string, i)) {
+            if ((i = string2.indexOf(95, i)) < 0) {
+                return false;
+            }
+            ++i;
+        }
+        return true;
+    }
+
+    public static Optional<String> getStringToSuggest(String checkedString, String input) {
+        if (checkedString.toLowerCase(Locale.ROOT).startsWith(input.toLowerCase(Locale.ROOT))) {
+            return Optional.of(checkedString);
+        } else {
+            if (checkedString.contains(":") && checkedString.length() - 1 >= checkedString.indexOf(':') + 1) {
+                if (checkedString.toLowerCase(Locale.ROOT).substring(checkedString.indexOf(':') + 1).startsWith(input.toLowerCase(Locale.ROOT)))
+                    return Optional.of(checkedString.substring(checkedString.indexOf(':') + 1));
+                else return Optional.empty();
+            } else if (checkedString.contains(".") && checkedString.length() - 1 >= checkedString.indexOf('.') + 1 && checkedString.toLowerCase(Locale.ROOT).substring(checkedString.indexOf('.') + 1).startsWith(input.toLowerCase(Locale.ROOT))) {
+                return Optional.of(checkedString.substring(checkedString.indexOf('.') + 1));
+            }
+        }
+        return Optional.empty();
+    }
+
+    public static boolean matchesKeyString(String checkedString, String input) {
+        if (checkedString.equals(input)) {
+            return true;
+        }
+        if (checkedString.contains(":") && checkedString.length() - 1 >= checkedString.indexOf(':') + 1) {
+            return checkedString.substring(checkedString.indexOf(':') + 1).equals(input);
+        }
+        return checkedString.contains(".") && checkedString.length() - 1 >= checkedString.indexOf('.') + 1 && checkedString.substring(checkedString.indexOf('.') + 1).equals(input);
+    }
+
+    public static String getEntityName(Entity entity) {
+        if (entity instanceof Mob) {
+            if (!LoggedPrintStream.removeColorCodes(((Mob) entity).getDisplayName()).isEmpty()) {
+                return LoggedPrintStream.removeColorCodes(((Mob) entity).getDisplayName());
+            }
+        } else if (entity instanceof ItemEntity && ((ItemEntity) entity).item != null) {
+            return LoggedPrintStream.removeColorCodes(((ItemEntity) entity).item.getDisplayName());
+        }
+        return EntityDispatcher.getEncodeId(entity);
+    }
+
+    public static int getVolume(CommandSource source, IntegerCoordinates first, IntegerCoordinates second) throws CommandSyntaxException {
+        return (int) (MathHelper.abs(first.getX(source) - second.getX(source)) * MathHelper.abs(first.getY(source, true) - second.getY(source, true)) * MathHelper.abs(first.getZ(source) - second.getZ(source)));
+    }
+
+    public static float linearInterpolation(float factor, float min, float max) {
+        return min + factor * (max - min);
+    }
+
+    public static boolean blockEntitiesAreEqual(CompoundTag first, CompoundTag second) {
+        if (first == null && second == null) return true;
+        if (first == null || second == null) return false;
+        for (Map.Entry<String, Tag<?>> entry : first.getValue().entrySet()) {
+            if (entry.getKey().equals("x") || entry.getKey().equals("y") || entry.getKey().equals("z")) continue;
+            if (!second.getValue().containsKey(entry.getKey()) || (second.getValue().get(entry.getKey()) != entry.getValue() && !second.getValue().get(entry.getKey()).equals(entry.getValue()) && !second.getValue().get(entry.getKey()).getValue().equals(entry.getValue().getValue()))) {
+                return false;
+            }
+        }
+        for (Map.Entry<String, Tag<?>> entry : second.getValue().entrySet()) {
+            if (entry.getKey().equals("x") || entry.getKey().equals("y") || entry.getKey().equals("z")) continue;
+            if (!first.getValue().containsKey(entry.getKey()) || (first.getValue().get(entry.getKey()) != entry.getValue() && !first.getValue().get(entry.getKey()).equals(entry.getValue()) && !first.getValue().get(entry.getKey()).getValue().equals(entry.getValue().getValue()))) {
+                return false;
+            }
+        }
+        return true;
+    }
+
+    public static void setBlockEntity(WorldSource world, int x, int y, int z, CompoundTag tag) {
+        if (tag == null || world.getBlockEntity(x, y, z) == null) return;
+        tag.putInt("x", x);
+        tag.putInt("y", y);
+        tag.putInt("z", z);
+        world.getBlockEntity(x, y, z).readFromNBT(tag);
+    }
+
+    public static void setBlockEntity(WorldSource world, int x, int y, int z, BlockEntity blockEntity) {
+        setBlockEntity(world, x, y, z, tagFrom(blockEntity));
+    }
+
+    public static CompoundTag tagFrom(BlockEntity blockEntity) {
+        CompoundTag tag = new CompoundTag();
+        if (blockEntity != null) blockEntity.writeToNBT(tag);
+        return tag;
+    }
+
+    public static void init() {
+        try {
+            for (Class<?> aClass : CommandReflectionHelper.getAllClasses((className) -> className.startsWith("net.minecraft.core.world.generate.feature"))) {
+                if (WorldFeature.class.isAssignableFrom(aClass) && aClass != WorldFeature.class) {
+                    Class<? extends WorldFeature> worldGenClass = (Class<? extends WorldFeature>) aClass;
+                    WORLD_FEATURES.put(aClass.getSimpleName().substring(12), worldGenClass);
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/util/CommandReflectionHelper.java b/src/main/java/net/minecraft/core/net/command/util/CommandReflectionHelper.java
new file mode 100644
index 000000000..00ba01ef8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/CommandReflectionHelper.java
@@ -0,0 +1,61 @@
+package net.minecraft.core.net.command.util;
+
+import com.b100.utils.FileUtils;
+import com.b100.utils.interfaces.Condition;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Enumeration;
+import java.util.List;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+
+public class CommandReflectionHelper {
+    public static List<Class<?>> getAllClasses(Condition<String> classNameCondition) {
+        String[] classPathEntries;
+        ArrayList classes = new ArrayList();
+        for (String classPathEntry : classPathEntries = System.getProperty("java.class.path").split(";")) {
+            File file = new File(classPathEntry);
+            if (file.isDirectory()) {
+                int l = file.getAbsolutePath().length() + 1;
+                List<File> files = FileUtils.getAllFiles(file);
+                for (File file2 : files) {
+                    if (!file2.getName().endsWith(".class")) continue;
+                    tryAddClass(classes, file2.getAbsolutePath().substring(l), classNameCondition);
+                }
+            }
+            if (!file.isFile()) continue;
+            try {
+                ZipFile zip = new ZipFile(file);
+                Enumeration<? extends ZipEntry> entries = zip.entries();
+                while (entries.hasMoreElements()) {
+                    String entry = ((Object)entries.nextElement()).toString();
+                    if (!entry.endsWith(".class")) continue;
+                    tryAddClass(classes, entry, classNameCondition);
+                }
+                zip.close();
+            } catch (IOException e) {
+                e.printStackTrace();
+            }
+        }
+        return classes;
+    }
+
+    private static void tryAddClass(List<Class<?>> classes, String fileName, Condition<String> classNameCondition) {
+        String className = fileName.substring(0, fileName.length() - 6);
+        className = className.replace('\\', '.');
+        className = className.replace('/', '.');
+        if (classNameCondition == null || classNameCondition.isTrue(className)) {
+            Class<?> clazz = null;
+            try {
+                clazz = Class.forName(className);
+            } catch (Throwable e) {
+                System.err.println(e.getClass().getName() + ": " + e.getMessage());
+            }
+            if (clazz != null) {
+                classes.add(clazz);
+            }
+        }
+    }
+}
